#include "debug.h"
u16 led0pwmval=0;
u8 dir=1;

/*********************************************************************
 * @fn      TIM1_OutCompare_Init
 * @brief   Initializes TIM1 output compare.
 * @param   arr - the period value.
 *          psc - the prescaler value.
 *          ccp - the pulse value.
 * @return  none
 */
void TIM1_PWMOut_Init(u16 arr, u16 psc, u16 ccp)
{
    GPIO_InitTypeDef GPIO_InitStructure={0};
    TIM_OCInitTypeDef TIM_OCInitStructure={0};
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOD | RCC_APB2Periph_TIM1, ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( GPIOD, &GPIO_InitStructure );

    TIM_TimeBaseInitStructure.TIM_Period = arr;
    TIM_TimeBaseInitStructure.TIM_Prescaler = psc;
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit( TIM1, &TIM_TimeBaseInitStructure);

#if (PWM_MODE == PWM_MODE1)
  TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;

#elif (PWM_MODE == PWM_MODE2)
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;

#endif
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
    TIM_OCInitStructure.TIM_Pulse = ccp;
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;
    TIM_OC1Init( TIM1, &TIM_OCInitStructure );

    TIM_CtrlPWMOutputs(TIM1, ENABLE );
    TIM_OC1PreloadConfig( TIM1, TIM_OCPreload_Disable );
    TIM_ARRPreloadConfig( TIM1, ENABLE );
    TIM_Cmd( TIM1, ENABLE );
}

//-----------------------------------
void TIM2_Int_Init(u16 arr, u16 psc)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef        NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE); //ʹTIM2ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;           //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;        //Ӧȼ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); //ʹTIM2жϣж
    TIM_Cmd(TIM2, ENABLE); //TIM2ʹ
}
//---------------------------------
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));  //80us int
void TIM2_IRQHandler(void)
{
 //   static u8 i = 0;

    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) //TIM2жǷ
    {
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);    //TIM2жϹλ

        //80usжһ,ıƵ
        if(dir)
            led0pwmval++;
        else
            led0pwmval--;
        if(led0pwmval>50)
            dir=0;
        if(led0pwmval<30)
            dir=1;

        //ﲻͨ ???????????????????
        TIM1_PWMOut_Init( 100, led0pwmval, 50 );  //޸pwmƵ
        //??????????????
    }
}

/*********************************************************************
 * @fn      main
 * @brief   Main program.
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    SystemCoreClockUpdate();
    Delay_Init();

    TIM2_Int_Init(80,46);  //80usжһ
 //   u8 dir=1;
 //   u16 led0pwmval=0;//
    while(1)
    {
        Delay_Ms(10);
  /*
  //
        if(dir)
            led0pwmval++;
        else
            led0pwmval--;
        if(led0pwmval>50)
            dir=0;
        if(led0pwmval<30)
            dir=1;
        TIM1_PWMOut_Init( 100, led0pwmval, 50 ); //޸pwmƵ
*/
    }
}
